#! /usr/bin/env python
#from org.csstudio.opibuilder.scriptUtil import PVUtil
import struct
#import matplotlib.pyplot as plt
#import urllib2
import json
from random import betavariate
import math
import array
import epics
import numpy
import datetime
import time

localtime=time.localtime(time.time())
 
##### VARS #########
NameFile="emittance"
NameFile=NameFile+"_"+str(localtime.tm_year)+"-"+str(localtime.tm_mon)+"-"+str(localtime.tm_mday)+"_"+str(localtime.tm_hour)+"-"+str(localtime.tm_min)+".dat"

NbAngle = 0
NbAng=epics.PV('SCAN:PS.NPTS')
NbAngle=NbAng.get()

NbPos = 0
NbP=epics.PV('SCAN:MTR.NPTS')
NbPos=NbP.get()
 
Energie = 0
NRJ=epics.PV('SCAN:CALC-Energy-SP')
Energie=NRJ.get()

Frequence = 0
Freq=epics.PV('SYS0-EVG0:Mxc1-Frequency-SP')
Frequence=Freq.get()

PasMM = 0
PasMtr=epics.PV('SCAN:MTR.P4SI')
PasMM=PasMtr.get()

tabAng=0
MatAngle=epics.PV('SCAN:BUFF-ANGLE')
tabAng=MatAngle.get()

tabPos=0
MatPos=epics.PV('SCAN:BUFF-MTR-POS')
tabPos=MatPos.get()

tabCurr=0
MatCurr=epics.PV('SCAN:BUFF-CURRENT')
tabCurr=MatCurr.get()

###################################################################################
############################### PLOTWIN ###########################################
###################################################################################

#### OPEN FILE
PlotFile = open('/home/ess-user/data/tracePlot/'+NameFile, 'w+')
PlotFile.write("fichier  emittance: X\n")
PlotFile.write("HT ion (kV) : %i\n"%(Energie))
PlotFile.write("frequence (Hz) : %f\n"%(Frequence))
PlotFile.write("N points temps : 1\n")
PlotFile.write("pas de position (mm) : %f\n"%(PasMM))
PlotFile.write("N points  position (mm) : %i\n"%(NbPos))
PlotFile.write("N points angle (mrad) : %i\n"%(NbAngle))
 
## POSITION
PlotFile.write("vecteur positions (mm) : ")
for value in range(0,NbPos):
     PlotFile.write("%f "%tabPos[value]);


## ANGLES
PlotFile.write("\nvecteur angles (mrad) : ")
indAngle=0
for value in range(0,NbAngle):
    PlotFile.write("%f "%tabAng[indAngle]);
    indAngle=indAngle+NbPos

PlotFile.write("\ntype d'ion : PROTON...")      
PlotFile.write("\ncolonnes de 1 a 4 : indice de temps / indice position / indice angle / I [Volt] :\n")
 
## POSITION/ANGLE/INTENSITY
indCurrent=NbPos-1
indPos=NbPos-1
for valuePos in range(0,NbPos):
	for valueAngle in range(0,NbAngle):
    		PlotFile.write("0\t%i\t%i\t%f\n" %(valuePos,valueAngle,tabCurr[indCurrent]));
		indCurrent=indCurrent+NbPos
	indPos=indPos-1
	indCurrent=indPos

PlotFile.close()

###################################################################################
############################### PLOTWIN ###########################################
###################################################################################

#### OPEN FILE
PlotFile = open('/home/ess-user/data/rawData/'+NameFile+"-raw.txt", 'w+')

## POSITION/ANGLE/INTENSITY
indCurrent=0
indAngle=0
indPos=0

for valuePos in tabPos:
	for valueAngle in tabAng:
    		PlotFile.write("0\t%f\t%f\t%f\n" %(valuePos[indPos],valueAngle[indAngle],tabCurr[indCurrent]));
		indCurrent=indCurrent+NbPos
		indAngle=indAngle+1
	indPos=indPos+1
	indCurrent=indPos

PlotFile.close()

